{
   muu TrueColor library for TMT Pascal - Nova direct copy routines
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

PROCEDURE Nx86_DIRECT4(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height

@@line_loop:
    mov  ecx, wdt   // width
    rep  movsd

    add  esi, snl   // source next line
    add  edi, tnl   // target next line
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Nx86_DIRECT3(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height
    
@@line_loop:
    mov  ecx, wdt   // width

@@pixel_loop:
    movsw
    movsb
    dec  ecx
    jnz  @@pixel_loop

    add  esi, snl   // source next line
    add  edi, tnl   // target next line
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Nx86_DIRECT2(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height
    
@@line_loop:
    mov  ecx, wdt   // width
    rep  movsw

    add  esi, snl   // source next line
    add  edi, tnl   // target next line
    dec  edx
    jnz  @@line_loop
END;

PROCEDURE Nx86_DIRECT1(src,tgt:pointer;wdt,hgt,snl,tnl:dword); assembler;
ASM
    mov  esi, src   // source
    mov  edi, tgt   // target
    mov  edx, hgt   // height
    
@@line_loop:
    mov  ecx, wdt   // width
    rep  movsb

    add  esi, snl   // source next line
    add  edi, tnl   // target next line
    dec  edx
    jnz  @@line_loop
END;
